diff --git a/base/deploy/src/scriptlets/security_databases.py b/base/deploy/src/scriptlets/security_databases.py
index 093e5ec..f32b7e4 100644
--- a/base/deploy/src/scriptlets/security_databases.py
+++ b/base/deploy/src/scriptlets/security_databases.py
@@ -22,6 +22,7 @@
 # PKI Deployment Imports
 import pkiconfig as config
 from pkiconfig import pki_master_dict as master
+import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
 
@@ -33,20 +34,96 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     def spawn(self):
         config.pki_log.info(log.SECURITY_DATABASES_SPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
-        config.pki_log.info("NOT YET IMPLEMENTED",
-                            extra=config.PKI_INDENTATION_LEVEL_2)
+        if not config.pki_dry_run_flag:
+            util.password.create_password_conf(
+                master['pki_shared_password_conf'])
+            util.file.modify(master['pki_shared_password_conf'])
+            util.certutil.create_security_databases(
+                master['pki_database_path'],
+                master['pki_shared_password_conf'])
+            util.file.modify(master['pki_cert_database'], perms=\
+                config.PKI_DEPLOYMENT_DEFAULT_SECURITY_DATABASE_PERMISSIONS)
+            util.file.modify(master['pki_key_database'], perms=\
+                config.PKI_DEPLOYMENT_DEFAULT_SECURITY_DATABASE_PERMISSIONS)
+            util.file.modify(master['pki_secmod_database'], perms=\
+                config.PKI_DEPLOYMENT_DEFAULT_SECURITY_DATABASE_PERMISSIONS)
+            rv = util.certutil.verify_certificate_exists(
+                     master['pki_database_path'],
+                     master['pki_self_signed_token'],
+                     master['pki_self_signed_nickname'],
+                     password_file=master['pki_shared_password_conf'])
+            if not rv:
+                util.file.generate_noise_file(
+                    master['pki_self_signed_noise_file'],
+                    master['pki_self_signed_noise_bytes'])
+                util.certutil.generate_self_signed_certificate(
+                    master['pki_database_path'],
+                    master['pki_self_signed_token'],
+                    master['pki_self_signed_nickname'],
+                    master['pki_self_signed_subject'],
+                    master['pki_self_signed_serial_number'],
+                    master['pki_self_signed_validity_period'],
+                    master['pki_self_signed_issuer_name'],
+                    master['pki_self_signed_trustargs'],
+                    master['pki_self_signed_noise_file'],
+                    password_file=master['pki_shared_password_conf'])
+                util.file.delete(master['pki_self_signed_noise_file'])
+        else:
+            util.password.create_password_conf(
+                master['pki_shared_password_conf'])
+            util.certutil.create_security_databases(
+                master['pki_database_path'],
+                master['pki_shared_password_conf'])
+            rv = util.certutil.verify_certificate_exists(
+                     master['pki_database_path'],
+                     master['pki_self_signed_token'],
+                     master['pki_self_signed_nickname'],
+                     password_file=master['pki_shared_password_conf'])
+            if not rv:
+                util.file.generate_noise_file(
+                    master['pki_self_signed_noise_file'],
+                    master['pki_self_signed_noise_bytes'])
+                util.certutil.generate_self_signed_certificate(
+                    master['pki_database_path'],
+                    master['pki_self_signed_token'],
+                    master['pki_self_signed_nickname'],
+                    master['pki_self_signed_subject'],
+                    master['pki_self_signed_serial_number'],
+                    master['pki_self_signed_validity_period'],
+                    master['pki_self_signed_issuer_name'],
+                    master['pki_self_signed_trustargs'],
+                    master['pki_self_signed_noise_file'],
+                    password_file=master['pki_shared_password_conf'])
         return self.rv
 
     def respawn(self):
         config.pki_log.info(log.SECURITY_DATABASES_RESPAWN_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
-        config.pki_log.info("NOT YET IMPLEMENTED",
-                            extra=config.PKI_INDENTATION_LEVEL_2)
+        util.file.modify(master['pki_shared_password_conf'])
+        util.file.modify(master['pki_cert_database'],
+            perms=config.PKI_DEPLOYMENT_DEFAULT_SECURITY_DATABASE_PERMISSIONS)
+        util.file.modify(master['pki_key_database'],
+            perms=config.PKI_DEPLOYMENT_DEFAULT_SECURITY_DATABASE_PERMISSIONS)
+        util.file.modify(master['pki_secmod_database'],
+            perms=config.PKI_DEPLOYMENT_DEFAULT_SECURITY_DATABASE_PERMISSIONS)
         return self.rv
 
     def destroy(self):
         config.pki_log.info(log.SECURITY_DATABASES_DESTROY_1, __name__,
                             extra=config.PKI_INDENTATION_LEVEL_1)
-        config.pki_log.info("NOT YET IMPLEMENTED",
-                            extra=config.PKI_INDENTATION_LEVEL_2)
+        if not config.pki_dry_run_flag:
+            if master['pki_subsystem'] in config.PKI_SUBSYSTEMS and\
+               util.instance.pki_subsystem_instances() == 0:
+                util.file.delete(master['pki_cert_database'])
+                util.file.delete(master['pki_key_database'])
+                util.file.delete(master['pki_secmod_database'])
+                util.file.delete(master['pki_shared_password_conf'])
+        else:
+            # ALWAYS display correct information (even during dry_run)
+            if master['pki_subsystem'] in config.PKI_SUBSYSTEMS and\
+               util.instance.pki_subsystem_instances() == 1:
+                util.file.delete(master['pki_cert_database'])
+                util.file.delete(master['pki_key_database'])
+                util.file.delete(master['pki_secmod_database'])
+                util.file.delete(master['pki_shared_password_conf'])
         return self.rv
diff --git a/base/deploy/src/scriptlets/slot_substitution.py b/base/deploy/src/scriptlets/slot_substitution.py
new file mode 100644
index 0000000..0a52af9
--- /dev/null
+++ b/base/deploy/src/scriptlets/slot_substitution.py
@@ -0,0 +1,120 @@
+#!/usr/bin/python -t
+# Authors:
+#     Matthew Harmsen <mharmsen@redhat.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Copyright (C) 2012 Red Hat, Inc.
+# All rights reserved.
+#
+
+# PKI Deployment Imports
+import pkiconfig as config
+from pkiconfig import pki_master_dict as master
+from pkiconfig import pki_slots_dict as slots
+import pkihelper as util
+import pkimessages as log
+import pkiscriptlet
+
+
+# PKI Deployment Instance Population Classes
+class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
+    rv = 0
+
+    def spawn(self):
+        config.pki_log.info(log.SLOT_ASSIGNMENT_SPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        util.file.copy_with_slot_substitution(master['pki_source_cs_cfg'],
+                                              master['pki_target_cs_cfg'])
+        util.file.copy_with_slot_substitution(master['pki_source_registry'],
+                                              master['pki_target_registry'])
+        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            util.file.copy_with_slot_substitution(
+                master['pki_source_catalina_properties'],
+                master['pki_target_catalina_properties'])
+            util.file.copy_with_slot_substitution(
+                master['pki_source_servercertnick_conf'],
+                master['pki_target_servercertnick_conf'])
+            util.file.copy_with_slot_substitution(
+                master['pki_source_server_xml'],
+                master['pki_target_server_xml'])
+            util.file.copy_with_slot_substitution(
+                master['pki_source_tomcat_conf'],
+                master['pki_target_tomcat_conf'],
+                overwrite_flag=True)
+            util.file.copy_with_slot_substitution(
+                master['pki_source_index_jsp'],
+                master['pki_target_index_jsp'],
+                overwrite_flag=True)
+            util.file.apply_slot_substitution(
+                master['pki_target_velocity_properties'])
+            util.file.apply_slot_substitution(
+                master['pki_target_subsystem_web_xml'])
+            if master['pki_subsystem'] == "CA":
+                util.file.copy_with_slot_substitution(
+                    master['pki_source_proxy_conf'],
+                    master['pki_target_proxy_conf'])
+                util.file.apply_slot_substitution(
+                    master['pki_target_profileselect_template'])
+        return self.rv
+
+    def respawn(self):
+        config.pki_log.info(log.SLOT_ASSIGNMENT_RESPAWN_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        util.file.copy_with_slot_substitution(master['pki_source_cs_cfg'],
+                                              master['pki_target_cs_cfg'],
+                                              overwrite_flag=True)
+        util.file.copy_with_slot_substitution(master['pki_source_registry'],
+                                              master['pki_target_registry'],
+                                              overwrite_flag=True)
+        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            util.file.copy_with_slot_substitution(
+                master['pki_source_catalina_properties'],
+                master['pki_target_catalina_properties'],
+                overwrite_flag=True)
+            util.file.copy_with_slot_substitution(
+                master['pki_source_servercertnick_conf'],
+                master['pki_target_servercertnick_conf'],
+                overwrite_flag=True)
+            util.file.copy_with_slot_substitution(
+                master['pki_source_server_xml'],
+                master['pki_target_server_xml'],
+                overwrite_flag=True)
+            util.file.copy_with_slot_substitution(
+                master['pki_source_tomcat_conf'],
+                master['pki_target_tomcat_conf'],
+                overwrite_flag=True)
+            util.file.copy_with_slot_substitution(
+                master['pki_source_index_jsp'],
+                master['pki_target_index_jsp'],
+                overwrite_flag=True)
+            util.file.apply_slot_substitution(
+                master['pki_target_velocity_properties'])
+            util.file.apply_slot_substitution(
+                master['pki_target_subsystem_web_xml'])
+            if master['pki_subsystem'] == "CA":
+                util.file.copy_with_slot_substitution(
+                    master['pki_source_proxy_conf'],
+                    master['pki_target_proxy_conf'],
+                    overwrite_flag=True)
+                util.file.apply_slot_substitution(
+                    master['pki_target_profileselect_template'])
+        return self.rv
+
+    def destroy(self):
+        config.pki_log.info(log.SLOT_ASSIGNMENT_DESTROY_1, __name__,
+                            extra=config.PKI_INDENTATION_LEVEL_1)
+        config.pki_log.info("NOTHING NEEDS TO BE IMPLEMENTED",
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+        return self.rv
diff --git a/base/deploy/src/scriptlets/subsystem_layout.py b/base/deploy/src/scriptlets/subsystem_layout.py
index b71fe39..7dc3471 100644
--- a/base/deploy/src/scriptlets/subsystem_layout.py
+++ b/base/deploy/src/scriptlets/subsystem_layout.py
@@ -36,29 +36,38 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # establish instance-based subsystem base
         util.directory.create(master['pki_subsystem_path'])
-        if master['pki_subsystem'] == "CA":
-            util.directory.copy(master['pki_source_emails'],
-                                master['pki_subsystem_emails_path'])
-            util.directory.copy(master['pki_source_profiles'],
-                                master['pki_subsystem_profiles_path'])
         # establish instance-based subsystem logs
         util.directory.create(master['pki_subsystem_log_path'])
         if master['pki_subsystem'] in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
             util.directory.create(master['pki_subsystem_signed_audit_log_path'])
         # establish instance-based subsystem configuration
-        util.directory.copy(master['pki_source_conf'],
-                            master['pki_subsystem_configuration_path'])
+        util.directory.create(master['pki_subsystem_configuration_path'])
+        # util.directory.copy(master['pki_source_conf_path'],
+        #                     master['pki_subsystem_configuration_path'])
         # establish instance-based subsystem registry
         util.directory.create(master['pki_subsystem_registry_path'])
-        # establish convenience symbolic links
-        util.symlink.create(master['pki_database_path'],
+        # establish instance-based Apache/Tomcat specific subsystems
+        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            # establish instance-based Tomcat PKI subsystem base
+            if master['pki_subsystem'] == "CA":
+                util.directory.copy(master['pki_source_emails'],
+                                    master['pki_subsystem_emails_path'])
+                util.directory.copy(master['pki_source_profiles'],
+                                    master['pki_subsystem_profiles_path'])
+            # establish instance-based Tomcat PKI subsystem logs
+            # establish instance-based Tomcat PKI subsystem configuration
+            # establish instance-based Tomcat PKI subsystem registry
+            # establish instance-based Tomcat PKI subsystem convenience
+            # symbolic links
+            util.symlink.create(master['pki_tomcat_webapps_path'],
+                                master['pki_subsystem_tomcat_webapps_link'])
+        # establish instance-based subsystem convenience symbolic links
+        util.symlink.create(master['pki_webserver_database_link'],
                             master['pki_subsystem_database_link'])
         util.symlink.create(master['pki_subsystem_configuration_path'],
-                            master['pki_subsystem_configuration_link'])
+                            master['pki_subsystem_conf_link'])
         util.symlink.create(master['pki_subsystem_log_path'],
                             master['pki_subsystem_logs_link'])
-        util.symlink.create(master['pki_webapps_path'],
-                            master['pki_subsystem_webapps_link'])
         return self.rv
 
     def respawn(self):
@@ -66,28 +75,37 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # update instance-based subsystem base
         util.directory.modify(master['pki_subsystem_path'])
-        if master['pki_subsystem'] == "CA":
-            util.directory.copy(master['pki_source_emails'],
-                                master['pki_subsystem_emails_path'],
-                                overwrite_flag=True)
-            util.directory.copy(master['pki_source_profiles'],
-                                master['pki_subsystem_profiles_path'],
-                                overwrite_flag=True)
         # update instance-based subsystem logs
         util.directory.modify(master['pki_subsystem_log_path'])
         if master['pki_subsystem'] in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
             util.directory.modify(master['pki_subsystem_signed_audit_log_path'])
         # update instance-based subsystem configuration
-        util.directory.copy(master['pki_source_conf'],
-                            master['pki_subsystem_configuration_path'],
-                            overwrite_flag=True)
+        util.directory.modify(master['pki_subsystem_configuration_path'])
+        # util.directory.copy(master['pki_source_conf_path'],
+        #                     master['pki_subsystem_configuration_path'])
+        #                     overwrite_flag=True)
         # update instance-based subsystem registry
         util.directory.modify(master['pki_subsystem_registry_path'])
-        # update convenience symbolic links
+        # establish instance-based Apache/Tomcat specific subsystems
+        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            # update instance-based Tomcat PKI subsystem base
+            if master['pki_subsystem'] == "CA":
+                util.directory.copy(master['pki_source_emails'],
+                                    master['pki_subsystem_emails_path'],
+                                    overwrite_flag=True)
+                util.directory.copy(master['pki_source_profiles'],
+                                    master['pki_subsystem_profiles_path'],
+                                    overwrite_flag=True)
+            # update instance-based Tomcat PKI subsystem logs
+            # update instance-based Tomcat PKI subsystem configuration
+            # update instance-based Tomcat PKI subsystem registry
+            # update instance-based Tomcat PKI subsystem convenience
+            # symbolic links
+            util.symlink.modify(master['pki_subsystem_tomcat_webapps_link'])
+        # update instance-based subsystem convenience symbolic links
         util.symlink.modify(master['pki_subsystem_database_link'])
-        util.symlink.modify(master['pki_subsystem_configuration_link'])
+        util.symlink.modify(master['pki_subsystem_conf_link'])
         util.symlink.modify(master['pki_subsystem_logs_link'])
-        util.symlink.modify(master['pki_subsystem_webapps_link'])
         return self.rv
 
     def destroy(self):
@@ -95,10 +113,12 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                             extra=config.PKI_INDENTATION_LEVEL_1)
         # remove instance-based subsystem base
         if master['pki_subsystem'] == "CA":
-            util.directory.delete(master['pki_subsystem_profiles_path'])
             util.directory.delete(master['pki_subsystem_emails_path'])
+            util.directory.delete(master['pki_subsystem_profiles_path'])
         util.directory.delete(master['pki_subsystem_path'])
         # remove instance-based subsystem logs
+        if master['pki_subsystem'] in config.PKI_SIGNED_AUDIT_SUBSYSTEMS:
+            util.directory.delete(master['pki_subsystem_signed_audit_log_path'])
         util.directory.delete(master['pki_subsystem_log_path'])
         # remove instance-based subsystem configuration
         util.directory.delete(master['pki_subsystem_configuration_path'])
diff --git a/base/deploy/src/scriptlets/war_explosion.py b/base/deploy/src/scriptlets/war_explosion.py
index 4f235d8..1a89c9f 100644
--- a/base/deploy/src/scriptlets/war_explosion.py
+++ b/base/deploy/src/scriptlets/war_explosion.py
@@ -36,16 +36,16 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             config.pki_log.info(log.WAR_EXPLOSION_SPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             # deploy war file
-            util.directory.create(master['pki_webapps_subsystem_path'])
+            util.directory.create(master['pki_tomcat_webapps_subsystem_path'])
             util.war.explode(master['pki_war'],
-                             master['pki_webapps_subsystem_path'])
+                             master['pki_tomcat_webapps_subsystem_path'])
             # establish convenience symbolic links
-            util.symlink.create(master['pki_webapps_webinf_classes_path'],
-                master['pki_webapps_subsystem_webinf_classes_link'])
-            util.symlink.create(master['pki_webapps_webinf_lib_path'],
-                master['pki_webapps_subsystem_webinf_lib_link'])
+            util.symlink.create(master['pki_tomcat_webapps_webinf_classes_path'],
+                master['pki_tomcat_webapps_subsystem_webinf_classes_link'])
+            util.symlink.create(master['pki_tomcat_webapps_webinf_lib_path'],
+                master['pki_tomcat_webapps_subsystem_webinf_lib_link'])
             # set ownerships, permissions, and acls
-            util.directory.set_mode(master['pki_webapps_subsystem_path'])
+            util.directory.set_mode(master['pki_tomcat_webapps_subsystem_path'])
         return self.rv
 
     def respawn(self):
@@ -53,17 +53,17 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             config.pki_log.info(log.WAR_EXPLOSION_RESPAWN_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
             # redeploy war file
-            util.directory.modify(master['pki_webapps_subsystem_path'])
+            util.directory.modify(master['pki_tomcat_webapps_subsystem_path'])
             util.war.explode(master['pki_war'],
-                             master['pki_webapps_subsystem_path'])
+                             master['pki_tomcat_webapps_subsystem_path'])
             # update ownerships, permissions, and acls
             # NOTE:  This includes existing convenience symbolic links
-            util.directory.set_mode(master['pki_webapps_subsystem_path'])
+            util.directory.set_mode(master['pki_tomcat_webapps_subsystem_path'])
         return self.rv
 
     def destroy(self):
         if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             config.pki_log.info(log.WAR_EXPLOSION_DESTROY_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
-            util.directory.delete(master['pki_webapps_subsystem_path'])
+            util.directory.delete(master['pki_tomcat_webapps_subsystem_path'])
         return self.rv
